#include <stdio.h>
#include <stdlib.h>

typedef long long ll;

int main(){
    int N,Q,i,j,s;
    scanf("%d %d",&N,&Q);

    ll d[N],k[Q],ima,ukup;
    int p[N];
    
    for(i=0;i<N;i++){
        scanf("%lld %lld",&d[i],&p[i]);
    }
    
    for(i=0;i<Q;i++){
        scanf("%lld",&k[i]);
    }
    
    for(i=0;i<Q;i++){
    	s=0;
    	ima=0;
    	ukup=0;
    	
        for(j=0;j<=k[i];j+=d[s]){
        	
        	ima+=p[s];
        	s++;
			
            if(ima-d[s]+d[s-1]<0){
                ukup+=ima;
                ima=0;
            }
        }
        ukup+=ima;
        printf("%lld\n",ukup);
    }
    
    return 0;
}